/****************************************************************************
 *                                                                          *
 * The contents of this file are subject to the WebStone Public License     *
 * Version 1.0 (the "License"); you may not use this file except in         *
 * compliance with the License. You may obtain a copy of the License        *
 * at http://www.mindcraft.com/webstone/license10.html                      *
 *                                                                          *
 * Software distributed under the License is distributed on an "AS IS"      *
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See      *
 * the License for the specific language governing rights and limitations   *
 * under the License.                                                       *
 *                                                                          *
 * The Original Code is WebStone 2.5.                                       *
 *                                                                          *
 * The Initial Developer of the Original Code is Silicon Graphics, Inc.     *
 * and Mindcraft, Inc.. Portions created by Silicon Graphics. and           *
 * Mindcraft. are Copyright (C) 1995-1998 Silicon Graphics, Inc. and        *
 * Mindcraft, Inc. All Rights Reserved.                                     *
 *                                                                          *
 * Contributor(s): ______________________________________.                  *
 *                                                                          *
 * @(#) bench.c 2.4@(#)                                                     *
 ***************************************************************************/

 
/* THIS IS WHERE WE GO OUT AND FETCH A URL */

// #include <iostream>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <async.h>
// 

#ifndef WIN32
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netinet/in.h>
#include <netdb.h>
#endif /* WIN32 */

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#ifdef SUNOS
#include <unistd.h>
#endif
#include <ctype.h>

#ifdef WIN32
#include <io.h>
#include <windows.h>
#include <winsock.h>
#endif /* WIN32 */

#include "sysdep.h"
#include "bench.h"


#define ACCEPT_COMMAND "Accept: */* HTTP/1.0\r\n\r\n"
#define ACCEPT_COMMAND_LEN 	((int)strlen(ACCEPT_COMMAND))
#define MAXCOMMANDLEN	256
#define HEADERBUFSIZ	(8*1024)
#define SAVE_FILE "savefile"

#define ENTERFUNC ({gp->inccount();})
#define EXITFUNC ({if(gp->tstate == 0 && gp->state!=DONE) delaycb(0, 0, wrap(gp, &get_params::dotimeout)); gp->deccount();})
#define CHECKGP if(gp->state == TRANS) fatal << "Enter in transient state\n"

#ifndef HAVE_STRNCASECMP
#define UPPER(c) (((c) >= 'a' && (c) <= 'z') ? (c) + 'A' - 'a' : (c))

int gconnects=0;
int global_gp_id=0;
int toomanyfiles=0;
int waitforcookie=0;
int x_puzzle_drops=0;

int num_socks=0;
int max_valid_prange=0;
int *portranges;

int pending_makeloads=0;
int pending_gps=0;

int x_all_bytes=0;

int init_port_ranges(){

  if(min_port_range == -1) {
    min_port_range = MIN_PORT_VAL;
    size_port_range = MAX_PORT_VAL - MIN_PORT_VAL;
  }
  num_port_ranges = size_port_range/PORTRANGESIZE;
  if(min_port_range % PORTRANGESIZE != 0)
    min_port_range -= (min_port_range % PORTRANGESIZE);

  printf("Port Ranges: Min: %d, Size: %d, Num: %d\n", 
	 min_port_range, size_port_range, num_port_ranges);
  fflush(stdout);

  portranges = (int*) mymalloc(sizeof(int) * (num_port_ranges+1));
  if(!portranges) return 1;
  
  max_valid_prange = num_port_ranges;
  for(int i=0; i<num_port_ranges; i++){
    portranges[i] = (i*PORTRANGESIZE)+min_port_range;
    if(portranges[i] > min_port_range+size_port_range)
      fatal << "DIE bad port, i " << i << "val " << portranges[i] << "\n";
  }
  portranges[max_valid_prange] = -1;
}

int get_port_range(){
  int retval = -1;
  if(max_valid_prange > 0) {
    float f = (RANDOM() * 1.0)/RAND_MAX;
    int x = (int)(f*max_valid_prange);

    if(GENDEBUG)
      printf("max: %d, rand: %d, val: %d, pending: %d, numsocks: %d\n", 
	     max_valid_prange, x, portranges[x], pending_makeloads, num_socks);
    retval = portranges[x];
    portranges[x]=portranges[max_valid_prange-1];
    portranges[--max_valid_prange] = -1;
  }else
    fatal ("out of ports\n");

  return retval;
}

int leave_port_range(int x){

  if(max_valid_prange >= num_port_ranges) 
    fatal << "cannot leave\n";
  portranges[max_valid_prange++] = x;
  if(GENDEBUG)
    printf("leave %d, max: %d, val: %d, end: %d, pending: %d\n", 
	   x, max_valid_prange, portranges[max_valid_prange-1], 
	   portranges[max_valid_prange], pending_makeloads);
  return 0;
}

class get_params: public virtual refcount {
 public:
  char url[URL_SIZE];
  char* cookie;
  rqst_timer_t *timer;
  char *postdata; 
  input_fields_t *inputs;
  char **set_cookie;
  strbuf data;
  callback<void>::ptr cb;
  MakeLoad* m;
  int sessid, mlid;

  /* for timeout */
  int state;
  tcpconnect_t* connp;
  int sock;
  timecb_t *timeout_timer;
  int remote_port;
  int num_attempts;
  int tstate;

  int me;
  int contentseentillnow,headerread;

  get_params(MakeLoad* m1, char *u, char* c, rqst_timer_t *rt, 
	     char *p, 
	     input_fields_t *i, char **s, int rp,
	     callback<void>::ptr callback): 
	contentseentillnow(0), headerread(0){

    pending_gps++;
    
    me = global_gp_id++;

    m = m1;
    memset(url, 0, URL_SIZE);
    strncpy(url, u, URL_SIZE-1);
    cookie = c;
    timer = rt;
    postdata = p;
    inputs = i;
    set_cookie = s;
    cb = callback;
    sock = -1;
    state = -1;
    connp = 0; 
    num_attempts = 0;
    tstate = -1;

    remote_port = rp;

    sessid = m->pid;
    mlid = m->mid;

#ifdef USEPORTRANGES
    if(http_guard)
      //timeout_timer=0;
      timeout_timer = delaycb(REQ_TIMEOUT, 0, wrap(this, &get_params::timeout));
    else
      timeout_timer = delaycb(AREQ_TIMEOUT, 0, wrap(this, &get_params::timeout));      
 
    if(DEBUG0206)
      fprintf(stderr, "%d:%d:%d timer: %x, refcnt: %d\n", 
	    sessid, mlid, me, timeout_timer, refcount_getcnt());
#else

    if(http_guard)
      //timeout_timer=0;
      timeout_timer = delaycb(REQ_TIMEOUT, 0, wrap(this, &get_params::timeout));
    else
      timeout_timer = delaycb(AREQ_TIMEOUT, 0, wrap(this, &get_params::timeout));      
#endif

  }
  
  ~get_params(){
    pending_gps --;
    if(me%100 == 0) warn ("pending gps: %d\n", pending_gps);

    if(DEBUG0206)
      fprintf(stderr, "%d:%d:%d gp del timer: %x\n", 
	    sessid, mlid, me, timeout_timer);

    if(tstate ==0) fatal << "inside timeout\n";

    if(timeout_timer){
      timecb_remove(timeout_timer);

      timeout_timer = 0; 
      if(GENDEBUG)
	fprintf(stderr, "%d:%d:%d gp del, timer removed \n", sessid, mlid, me);
    }
    if(GENDEBUG)
      fprintf(stderr, "%d:%d:%d gp del\n", sessid, mlid, me);
    data.tosuio()->clear();

    if(sock != -1) fatal << "sock not closed!\n";
  }

  inline void dotimeout(){
    inccount();
    
    mtimeouts++;
    switch(state) {
    case START:
      if(!connp) fatal << "BOO\n";
      tcpconnect_cancel(connp);
      sock = -1; /* tcpconnect_cancel gets rid of it! */
      connp = 0;
      break;
    case READ:
      if(sock<0) fatal << " Boo sock read\n";
      fdcb(sock, selread, 0);
      break;
    case WRITE:
      if(sock<0) fatal << " Boo sock write\n";
      fdcb(sock, selwrite, 0);
      break;
    case DONE:
      warn << "Done already\n";
      break;
    default:
      fatal << " bad state\n";
      break;
    }
    
    if(!BADSOCKET(sock)){
      if(DEBUG0206)
      warn << sessid << ":" << mlid  << ":" << me 
	   << ", " << sock << " closing sock in timeout!\n";
      NETCLOSE(sock);
      sock = -1;
      if(state == START) num_socks ++;
    }
      
    if(DEBUGASYNC)
      fprintf(stderr, "%d:%d:%d timeout done, timeout timer: %x\n", 
	      sessid, mlid, me, timeout_timer);
    
    /* tell m we bailed */
    this->m->returnval = -1;
    this->cb();

    tstate =1;
    deccount(); /* for this method */
  }

  void timeout(){
    if(DEBUG0206)
    fprintf(stderr, "%d:%d:%d timeout happens timer: %x, connp: %x\n", 
	    sessid, mlid, me, timeout_timer, connp);
    timeout_timer = 0;
    tstate = 0;
    
    if(state == TRANS){
      /* Process timeout right after gb is done
       */
      warn("%d:%d:%d timeout ignore!\n", 
	   sessid, mlid, me);
      //tstate = 1;
      return;
    }
    dotimeout();
  }
  
  int getcount(){
    return this->refcount_getcnt();
  }

  int inccount(){

    if(DEBUG0206)
      warn("\t%d:%d:%d enter cnt: %d\n", 
	   sessid, mlid, me, getcount());
    
    int x = this->refcount_getcnt();
    this->refcount_inc();
    return x;
  }
                                                                                
  int deccount(){
    if(DEBUG0206)
      warn("\t%d:%d:%d exit cnt: %d\n", 
	   sessid, mlid, me, getcount());
    
    int x = this->refcount_getcnt();
    if(x>0) this->refcount_dec();

    return x;
  }

};

/* compare two strings with max length, ignoring case */
int strncasecmp(const char *str1, const char *str2, size_t len) {
	int diff;

    while (*str1 && *str2 && len--) {
		if (diff = UPPER(*str1) - UPPER(*str2))
			return diff < 0 ? -1 : 1;
		str1++;
		str2++;
    }
    return 0;
}
#endif /* HAVE_STRNCASECMP */


char * get_attr(const char * body, const char * pattern, const char * attr) {

  char * retval = 0;
    char * mark = strstr(body, pattern);
    char * mark2 = 0;

    int idx = 0;

    if(mark == NULL) fatal ("no such pattern\n");

    mark = strstr(mark, attr);
    if(mark == NULL) fatal ("no such mark1\n");
    if( (mark = strchr(mark, '\'')) == NULL) fatal("no such mark again\n"); 
    mark += 1;

    mark2 = strchr(mark, '\'');
    if(mark2 == NULL) fatal ("no such mark2\n");

    retval = (char *) mymalloc(mark2 - mark + 1);
    memset(retval, 0, mark2 - mark + 1);
    memcpy(retval, mark, mark2 - mark);
    D_PRINTF("Got attr: %s\n", retval);

    return retval;
}

int local_socket_id(SOCKET sock){
  struct sockaddr_in address;
  int len = sizeof(address);

  if(getsockname(sock, (struct sockaddr *)(&address), (socklen_t*)&len) != 0){
    if(DEBUGASYNC) fprintf(stderr, "getsockname failed on socket %d\n", sock);
    return -1;
  }

  return ntohs(address.sin_port);
  
}

void body_read_t (int sock, int bodylength, ptr<get_params> gp)
{
  if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid << ":" << gp->me <<
      " begin body_read_t \n";

  gp->state = TRANS;
  int bytesread = (gp->data).tosuio()->input(sock);
  int totalbytesread;
  const char *body;
  str bodybufstr;

  ENTERFUNC;
  
  if (timeexpired)
    goto here_error4;
  
  if (bytesread < 0) {
    returnerr("Error during read of page body. Read "
	      "returns %d on socket %d, error: %s\n",
	      bytesread, sock, strerror(errno));
    goto here_error4;
  }

  if(BADSOCKET(sock)){
    warn << "sock=-1 in body_read_t\n";
    goto here_error4;
  }
  
  if(bytesread != 0) {
    /* redo */
    x_all_bytes += bytesread;
    gp->contentseentillnow+=bytesread;
    (gp->data).tosuio()->rembytes(bytesread);
    if(sock < 0) fatal ("bad sock 1\n");
    fdcb (sock, selread, wrap(&body_read_t, sock, bodylength, gp));
    gp->state = READ;
    EXITFUNC;
    return;  
  }
  
  totalbytesread = gp->contentseentillnow + (gp->data).tosuio()->resid() + gp->headerread;
  if(totalbytesread < 0) printf("boo boo alreadyseen: %d, rem: %d\n",
				gp->contentseentillnow, (gp->data).tosuio()->resid());
  bodybufstr = (gp->data);
  body = bodybufstr.cstr();

  /* done reading body 
  if ( bodylength && (totalbytesread) != bodylength) {
    fprintf(stderr,
	    "%d:%d:%d Warning: file length (%d) doesn't match Body-length (%d)\n",
	    gp->sessid, gp->mlid, gp->me,
	    totalbytesread, bodylength);
  }
  */

  if (gp->inputs && strstr(body, ".gif.hg") != NULL) {
    char * img_title = get_attr(body, "img", "src");
    char * temp_url;
    img_title += 2; /* advance past the "p-" */
    
    /* arg- hack.. not that the rest of this is not */
    
    temp_url = get_attr(body, "input type='hidden' name='u'", "value");
    gp->inputs->u = (char *) mymalloc(strlen(temp_url) + 2);
    memset(gp->inputs->u, 0, strlen(temp_url) + 2);
    memcpy(gp->inputs->u + 1, temp_url, strlen(temp_url));
    gp->inputs->u[0] = '/';
    free(temp_url);

    gp->inputs->h = get_attr(body, "input type='hidden' name='h'", "value");
    gp->inputs->k = get_attr(body, "input type='hidden' name='k'", "value");
    gp->inputs->img_idx = strtol(img_title, 0, 10);
    D_PRINTF("idx: %d\n", gp->inputs->img_idx);
    free(img_title - 2);
  }
    
  
  if(GETTIMEOFDAY(&(gp->timer)->afterbody, &(gp->timer)->afterbodyzone) != 0) {
    returnerr("Error retrieving afterbody\n");
    goto here_error4;
  }

  if(GETTIMEOFDAY(&(gp->timer)->exittime, &(gp->timer)->exittimezone) != 0)
    {
      D_PRINTF( "Error retrieving exit time: %s\n", strerror(errno) );
      returnerr("Error retrieving exit time\n");
      goto here_error4;
    }
  
  if(GENDEBUG)
    warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me 
	 << ": closing sock " << sock << " correct!\n";
  if(sock < 0) fatal ("bad sock 2\n");
  fdcb(sock, selread, 0);
  NETCLOSE(sock);
  if(sock != gp->sock) fatal << "socks mucked up!";
  gp->sock = -1;
  sock = -1;
 /* 
  fprintf(stderr, "get-async.c: session %d mlid %d totalbytes %d bodybytes %d\n", 
	  gp->sessid, gp->mlid,  totalbytesread, totalbytesread-gp->headerread);
*/
  gp->timer->valid = 2;
  gp->timer->totalbytes = totalbytesread;
  gp->timer->bodybytes = gp->contentseentillnow;
  
  if(DEBUGASYNC)
    fprintf (stderr, "%d:%d get returning totalbytes %d body %d valid %d\n", 
	     gp->sessid, gp->mlid, gp->timer->totalbytes, gp->timer->bodybytes, gp->timer->valid );
  
  D_PRINTF( "get returning start %d, end %d\n", 
	    gp->timer->entertime.tv_sec, gp->timer->exittime.tv_sec); 
  
  D_PRINTF( "get returning connect %d, request %d, header %d, body %d\n",
	    gp->timer->afterconnect.tv_sec, gp->timer->beforeheader.tv_sec, 
	    gp->timer->afterheader.tv_sec, gp->timer->afterbody.tv_sec );
  
  TRACE("get(): exiting successfully\n");

  gp->m->returnval=0;
  gp->cb();
  gp->state = DONE;

  //warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done\n";

  EXITFUNC;
  return;

 here_error4:
  gp->state = TRANS;
  //  if(DEBUGASYNC) 
  if(DEBUG0206)
    warn << "body_read(): entering error section\n";
    
  if (!BADSOCKET(sock)){
    fdcb(sock, selread, 0);  
    if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << 
      "closing sock " << sock << "\n";
    NETCLOSE(sock);
    if(sock != gp->sock) fatal << "sock muck4\n";
    gp->sock = -1;
    sock = -1;
  }
  GETTIMEOFDAY(&gp->timer->exittime, &gp->timer->exittimezone);

  gp->m->returnval = -1;
  gp->cb();
  warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done4\n";
  if(timeexpired) warn ("pending %d\n", pending_gps);

  gp->state = DONE;

  EXITFUNC;
  return;
}

void header_read_t(int sock, ptr<get_params> gp){
  if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid << ":" << gp->me <<
      " begin header_read_t \n";

  gp->state = TRANS;
  int	status;
  int readdone=0;
  int headerlen=0;
  char	version[100];
  int	count;
  char* offset;
  int contentlength=0;
  const char *rc;
  str r;
  
  int n;
  ENTERFUNC;

  if(timeexpired) goto here_error3;
  if(BADSOCKET(sock)){
    warn << "sock=-1 in header_read_t\n";
    goto here_error3;
  }

  n = (gp->data).tosuio()->input(sock);

  if(DEBUGASYNC) warn << "header, read "<< n <<" bytes \n"; 
  if (n <0) goto here_error3;

  r = (gp->data);
  rc = r.cstr();

  x_all_bytes += n;
  
  if (offset = strstr(rc, "\n\n"))  {
    headerlen = offset -rc + 2;
    readdone=1;
  }
  else if (offset = strstr(rc, "\n\r\n")) {
    headerlen = offset -rc + 3;
    readdone=1;
  }

  if(!readdone && n!=0) {
    if(sock < 0) fatal ("bad sock 3\n");
    fdcb(sock, selread, wrap(&header_read_t, sock, gp));
    gp->state = READ;
    EXITFUNC;
    return;
  }

  if (headerlen == 0) {
    //returnerr("Can't find the end of the header in \"%s\"\n", rc);
    goto here_error3;
  }
  
  if(DEBUGASYNC)
    fprintf(stderr, "%d:%d:%d header_read_t: headerlen=%d\n", 
	    gp->sessid, gp->mlid, gp->me, headerlen);
   gp->headerread = headerlen;   
 
  /* get and check status code from the first line of the header */
  count = sscanf(rc, "HTTP/%s %d", version, &status);
  if (count != 2) {
    returnerr("Bad status line in get(): %s for url [%s] session %d ml %d\n", 
	      rc, gp->url, gp->sessid, gp->mlid);
    goto here_error3;
  }

  if ((status < 200 || status > 300) && status != 404) {
    returnerr("Bad status (%d) in get() for url [%s] session %d ml %d\n", 
	      status, gp->url, gp->sessid, gp->mlid);
    goto here_error3;
  }
    
  /* get the content length line from the header */
  offset = (char *)rc;
  while(offset < rc + ((gp->data).tosuio()->resid()) && *offset != 0){
   if ( *(offset++) != '\n')
     continue;
   
   if (strncasecmp(offset, CONTENT_LENGTH_STRING, 
		   strlen(CONTENT_LENGTH_STRING)) == 0) 
     {
       sscanf(offset+strlen(CONTENT_LENGTH_STRING), "%d", &contentlength);
       if(DEBUGASYNC)
	 fprintf (stderr,  "%d:%d:%d Content-Length: %d\n", 
		gp->sessid, gp->mlid, gp->me,
		contentlength );
     }
  }
    
  /* find the set-cookie header */
  offset = (char*)rc;
  D_PRINTF( "Retrieving any set cookies\n" );
  if (gp->set_cookie) {
    *(gp->set_cookie) = (char *)mymalloc(BUFSIZE);
    memset(*(gp->set_cookie), 0, BUFSIZE);
  }
  
  while (gp->set_cookie &&
	 offset < rc+headerlen && *offset) {
    if (*offset++ != '\n')
      continue;
    
    if (strncasecmp(offset, SET_COOKIE_STRING, 
		    strlen(SET_COOKIE_STRING)) == 0)
      {
	sscanf(offset+strlen(SET_COOKIE_STRING), "%s", *(gp->set_cookie));
	D_PRINTF( "Set-Cookie: %s\n", *(gp->set_cookie ));
      }
  }
  
  if(GETTIMEOFDAY(&(gp->timer)->afterheader, &(gp->timer)->afterheaderzone) != 0) {
    returnerr("Error retrieving afterheader\n");
    goto here_error3;
  }
  
  D_PRINTF( "Parsed off set cookie\n");

  (gp->data).tosuio()->rembytes(headerlen);
  if(sock < 0) fatal ("bad sock 4\n");
  fdcb(sock, selread, 0); /* clear old state? */
  if(sock < 0) fatal ("bad sock 5\n");
  gp->contentseentillnow = 0;
  fdcb (sock, selread, wrap(&body_read_t, sock, contentlength, gp));
  gp->state = READ;

  EXITFUNC;
  return;

 here_error3:
  gp->state = TRANS;
  if(DEBUG0206)
    warn << "header_read(): entering error section\n";
  if (!BADSOCKET(sock)){
    fdcb(sock, selread, 0);
    if(DEBUG0206)
      warn << gp->sessid << ":" << 
	gp->mlid << ":" << gp->me  << "closing sock " << sock << "\n";
    NETCLOSE(sock);
    if(sock != gp->sock) fatal << "sock muck3\n";
    gp->sock = -1;
    sock=-1;
  }
  GETTIMEOFDAY(&(gp->timer)->exittime, &(gp->timer)->exittimezone);


  gp->m->returnval = -1;
  gp->cb();
  gp->state = DONE;
  //warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done3\n";
  if(timeexpired) warn ("pending %d\n", pending_gps);

  EXITFUNC;
  return;

}

void req_write_t(int sock, ptr<get_params> gp)
{
  if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid << ":" << gp->me <<
      " begin req_write_t \n";

  gp->state = TRANS;
  ENTERFUNC;

  int n;
  if(timeexpired) goto here_error2;
  if(BADSOCKET(sock)){
    warn << "sock=-1 in req_write_t\n";
    goto here_error2;
  }

  n = (gp->data).tosuio()->output(sock);

  if(n < 0) {
    if(DEBUGASYNC) warn << "Error sending command line to server.\n";
    goto here_error2;
  }
  
  if((gp->data).tosuio()->resid()){
    if(sock < 0) fatal ("bad sock 6\n");
    fdcb(sock, selwrite, wrap(&req_write_t, sock, gp));
    gp->state = WRITE;
    EXITFUNC;
    return;
  }
  
  if(DEBUGASYNC) warn << "req_write_t: done writing result \n";
  if(GETTIMEOFDAY(&(gp->timer)->beforeheader, &(gp->timer)->beforeheaderzone) != 0) {
    if(DEBUGASYNC) warn << "Error retrieving beforeheader\n";
    goto here_error2;
  }

  if(sock < 0) fatal ("bad sock 7\n");
  fdcb(sock, selwrite, 0);
  (gp->data).tosuio()->rembytes( (gp->data.tosuio())->resid() );
  if(sock < 0) fatal ("bad sock 8\n");
  fdcb(sock, selread, wrap(&header_read_t, sock, gp));
  gp->state = READ;
  EXITFUNC;
  return;

 here_error2:
  gp->state = TRANS;
  if(sock < 0) fatal ("bad sock 9\n");
  fdcb(sock, selwrite, 0);

  if(DEBUG0206)
    warn << "req_write(): entering error section\n";

  if (!BADSOCKET(sock)) {
    if(DEBUG0206)
      warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << 
      "closing sock " << sock << "\n";
    NETCLOSE(sock);
    if(sock != gp->sock) fatal << "sock muck2\n";
    gp->sock = -1;
    sock=-1;
  }
  GETTIMEOFDAY(&(gp->timer)->exittime, &(gp->timer)->exittimezone);

  gp->m->returnval = -1;
  gp->cb();
  gp->state = DONE;
  warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done2\n";

  EXITFUNC;
  return;
}

void connected_t(ptr<get_params> gp, int sock);

inline void start_t(ptr<get_params> gp) {
  if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid << ":" << gp->me <<
      " begin start_t \n";
  gp->state = TRANS;
  ENTERFUNC;

  if(timeexpired) goto here_error;
  
  if(GETTIMEOFDAY(&gp->timer->entertime, &gp->timer->entertimezone) != 0)
    fatal << "Error retrieving entertime\n";
  
  gp->timer->valid = 1;
  
  if(GETTIMEOFDAY(&gp->timer->beforeconnect, &gp->timer->beforeconnectzone) != 0)
    fatal << "Error retrieving beforeconnect\n";

#ifdef USEPORTRANGES
  int max_tries;
  max_tries = PORTRANGESIZE;
  {
    gp->sock = -1;
    
    int ptoget;
    errno = 0;
    
    while(gp->num_attempts < max_tries){
      ptoget = gp->m->whichport();
      gp->sock = inetsocket(SOCK_STREAM, ptoget, ntohl(local_addr));
      
      if(DEBUGASYNC)
	fprintf(stderr, "%d:%d:%d bind to port: %d, range: %hd, num: %d, sock: %hd, numsocks: %d\n", 
		gp->sessid, gp->mlid, gp->me,
		ptoget, gp->m->portrange, gp->num_attempts,
		gp->sock, num_socks);
      
      gp->num_attempts++;
      if(gp->sock > 0)
	break;
    }
    
    if(gp->sock < 0) {
      fprintf (stderr, "\n\n\n%d:%d:%d cannot bind: %s, num_socks: %d, port: %d\n", 
	      gp->sessid, gp->mlid, gp->me, 
	      strerror(errno), num_socks, ptoget);
      goto here_error;
    }
    gp->connp = tcpconnect(webserv_addr_in, gp->remote_port, gp->sock, 
			   wrap(&connected_t, gp));
  }
#else
  gp->connp = tcpconnect(webserv_addr_in, gp->remote_port, 
			   wrap(&connected_t, gp));
#endif

  if(!gp->connp){
    fprintf(stderr, "%d:%d:%d quick closure\n", gp->sessid, gp->mlid, gp->me);
  }
  if(DEBUG0206)
  fprintf(stderr, "%d:%d:%d connp: %x\n", gp->sessid, gp->mlid, gp->me, gp->connp);

  gp->state = START;
  EXITFUNC;
  return;
  
 here_error:
  gp->state = TRANS;
  if(DEBUGASYNC) warn << "get(): entering error section\n";
  GETTIMEOFDAY(&gp->timer->exittime, &gp->timer->exittimezone);

  gp->m->returnval = -1;
  gp->cb();
  gp->sock = -1;
  gp->state = DONE;
  warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done0\n";
  if(timeexpired) warn ("pending %d\n", pending_gps);

  EXITFUNC;
  return;
}

void connected_t (ptr<get_params> gp, int sock)
{
  if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid << ":" << gp->me <<
      " begin connected_t \n";

  gp->state = TRANS;
  gp->connp = 0;
  ENTERFUNC;


  strbuf* getcommand = &(gp->data);
  if(timeexpired) {
    warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << 
      "conn_t timeout " << sock << ", gp " << gp->sock << "\n";
    goto here_error1;
  }

  if (BADSOCKET(sock)){
    //returnerr("[%d:%d:%d] connect failed, err: %s, \n", 
    //	      gp->sessid, gp->mlid, gp->me,  strerror(errno));
    goto here_error1;
  }

  // tells u which port i bound to?
  // printf("socket bound to %d\n", local_socket_id(sock));

  if(GETTIMEOFDAY(&(gp->timer)->afterconnect, &(gp->timer)->afterconnectzone) != 0) {
    GETTIMEOFDAY(&(gp->timer)->exittime, &(gp->timer)->exittimezone);
    returnerr("Error retrieving afterconnect\n");	
    goto here_error1;
  }

  if(DEBUGASYNC) warn << "connected, making request \n";
  gconnects++;
  num_socks++;

  /*
   * SEND THE GET AND THE ACCEPT.
   */
  *(getcommand) << "GET " <<  gp->url;
  if (gp->postdata)
    *(getcommand) << "?" << gp->postdata;
  
  *getcommand << " HTTP/1.0\r\n";
  *getcommand << "HOST: " << webserver << "\r\n";
  
  if (gp->cookie)
    *getcommand << "Cookie: " << gp->cookie << "\r\n";
  
  *getcommand <<  ACCEPT_COMMAND;

  gp->sock = sock;
  gp->state = TRANS;
  
  if (sock < 0) fatal ("bad sock 10\n");
  fdcb(sock, selwrite, wrap(&req_write_t, sock, gp));

  gp->state = WRITE;
  EXITFUNC;
  return;
  
 here_error1:
  gp->state = TRANS;
  if(errno == EMFILE)
    toomanyfiles++;
  
  if (!BADSOCKET(sock)){
    //if(DEBUG0206)
    warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << 
      "closing sock " << sock << ", gp " << gp->sock << "\n";
    NETCLOSE(sock);
    if(!timeexpired && sock != gp->sock)
      fatal << "sock muck1\n";
    gp->sock = -1;
    sock = -1;
  }

  if(sock == -1) gp->sock = -1; /* conn bailed case */

  GETTIMEOFDAY(&(gp->timer)->exittime, &(gp->timer)->exittimezone);

  if(errno!=99) {
    gp->m->returnval = -1;
    gp->cb();
    //warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " all done1\n";
    gp->state = DONE;
  }else{
    /* SO_REUSE case */
    warn << gp->sessid << ":" << gp->mlid  << ":" << gp->me << " redo!\n";
    start_t(gp);
  }

  if(timeexpired) warn ("pending %d\n", pending_gps);

  EXITFUNC;
  return;
}

void
getasync(MakeLoad* const m,
	 char *loc, 
	 NETPORT port, 
	 char *url, 
	 char *cookie, 
	 rqst_timer_t *timer, 
	 char *postdata,
	 input_fields_t * inputs, 
	 char ** set_cookie,
	 callback<void>::ref cb)
{

  ptr<get_params> gp = New refcounted<get_params> (m, url, cookie, timer, 
		  postdata, inputs, set_cookie, port, cb);
  start_t(gp);
}
