# Generated automatically from Makefile.in by configure.
############################################################################
#                                                                          #
# The contents of this file are subject to the WebStone Public License     #
# Version 1.0 (the "License"); you may not use this file except in         #
# compliance with the License. You may obtain a copy of the License        #
# at http://www.mindcraft.com/webstone/license10.html                      #
#                                                                          #
# Software distributed under the License is distributed on an "AS IS"      #
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See      #
# the License for the specific language governing rights and limitations   #
# under the License.                                                       #
#                                                                          #
# The Original Code is WebStone 2.5.                                       #
#                                                                          #
# The Initial Developer of the Original Code is Silicon Graphics, Inc.     #
# and Mindcraft, Inc.. Portions created by Silicon Graphics. and           #
# Mindcraft. are Copyright (C) 1995#1998 Silicon Graphics, Inc. and        #
# Mindcraft, Inc. All Rights Reserved.                                     #
#                                                                          #
# Contributor(s): ______________________________________.                  #
#                                                                          #
############################################################################

#
# @(#) Makefile.in 2.7@(#)
#

PRODUCT = webstone
VERSION = 2.5b3

CC		= g++
LIBS		= -lnsl -lm -lasync -lsfscrypt -lsfsmisc -lresolv -ldmalloc

# rpm derived 0.7.2
LDFLAGS         = -L/usr/lib -L/export/scratch/sfs/lib/sfs -L/export/scratch/sfs/lib
INCLUDES	= -I/export/scratch/sfs/include/sfs -I/export/scratch/sfs/include -I/usr/include -I/include/linux

# 0.8pre old
#LDFLAGS         = -L/usr/lib -L/usr/local/lib/sfs -L/usr/local/lib
#INCLUDES	= -I/usr/local/include/sfs -I/usr/local/include -I/usr/include -I/include/linux

#cvs version 0.8pre new
LDFLAGS         = -L/usr/lib -L/export/scratch/sfs/cvs-import/install/lib/sfs -L/export/scratch/sfs/cvs-import/install/lib
INCLUDES	= -I/export/scratch/sfs/cvs-import/install/include/sfs -I/export/scratch/sfs/cvs-import/install/include -I/usr/include -I/include/linux
CFLAGS		= -g -O2
DEFS		= -DHTTP_GUARD -DHAVE_STRERROR -DUSE_TIMEZONE #-DDMALLOC
DEFS+		= -DHTTP_GUARD -DUSE_TIMEZONE -DASYNC -DDMALLOC #-DUSEPORTRANGES

BINDIR		= ../bin
CP		= cp
RM		= rm -f

EXECUTABLE1	= webmaster
MAIN1		= webmaster.c
EXECUTABLE2	= webclient
MAIN2		= webclient.c
EXECUTABLE3	= genrand
MAIN3		= genrand.c
EXECUTABLE4	= wcasync
MAIN4		= webclient-async.c
EXECUTABLE5     = logparser
MAIN5		= logparser.c

MASTERSRCS	= timefunc.c bench.c parse_file_list.c statistics.c \
		  errexit.c sysdep.c parse_answer_file.c

STONESRCS	= timefunc.c get.c \
		  parse_file_list.c bench.c statistics.c errexit.c \
		  sysdep.c parse_answer_file.c

ASYNCSRCS	= timefunc.c get-async.c replay_log.c \
		  parse_file_list.c bench.c statistics.c errexit.c \
		  sysdep.c parse_answer_file.c

COMPILE         = $(CC) $(CFLAGS) $(DEFS) $(INCLUDES)
COMPILE+         = $(CC) $(CFLAGS) $(DEFS+) $(INCLUDES)

MASTEROBJS = webmaster.o $(MASTERSRCS:.c=.o)
STONEOBJS = webclient.o $(STONESRCS:.c=.o)
ASYNCOBJS = webclient-async.o $(ASYNCSRCS:.c=.o)
PARSEROBJS = logparser.o replay_log.o timefunc.o statistics.o
GENRANDOBJS = genrand.o

TARGETS = $(EXECUTABLE1) $(EXECUTABLE2) $(EXECUTABLE3) $(EXECUTABLE4) ${EXECUTABLE5}

.SUFFIXES:
.SUFFIXES: .c .o

all:	$(TARGETS) 

install: all install-api install-cgi
	$(CP) $(TARGETS) $(BINDIR)

pure: all
	purify -mail-to-user=root webclient
	$(CP) webclient.pure $(BINDIR)/webclient
	$(RM) webclient.pure
	purify -mail-to-user=root webmaster
	$(CP) webmaster.pure $(BINDIR)/webmaster
	$(RM) webmaster.pure

clean:	
	$(RM) $(MASTEROBJS) $(STONEOBJS) $(GENRANDOBJS) ${ASYNCOBJS}
	$(RM) webmaster.pure webclient.pure

clobber: clean
	$(RM) config.cache config.log config.status config.h Makefile
	$(RM) $(TARGETS)
	(cd CGI-test; make clobber)
	(cd API-test; make clobber)

webmaster.o: webmaster.c bench.h parse_file_list.h statistics.h \
		sysdep.h timefunc.h debug.h config.h

webclient.o: webclient.c bench.h debug.h get.h \
		parse_file_list.h statistics.h sysdep.h timefunc.h config.h

webclient-async.o: webclient-async.c bench.h debug.h get.h replay.h \
		parse_file_list.h statistics.h sysdep.h timefunc.h config.h

timefunc.o: timefunc.c timefunc.h bench.h debug.h statistics.h \
		sysdep.h config.h

bench.o: bench.c bench.h debug.h statistics.h sysdep.h timefunc.h \
		config.h

logparser.o: replay.h logparser.c 

errexit.o: errexit.c sysdep.h config.h

statistics.o: statistics.c statistics.h sysdep.h config.h

webmaster: $(MASTEROBJS)
	$(COMPILE) $(LDFLAGS) $(MASTEROBJS) $(LIBPATH) $(LIBS) -o $(EXECUTABLE1)

webclient: $(STONEOBJS)
	$(COMPILE) $(LDFLAGS) $(STONEOBJS) $(LIBPATH) $(LIBS) -o $(EXECUTABLE2)

wcasync: $(ASYNCOBJS)
	$(COMPILE+) $(LDFLAGS) $(ASYNCOBJS) $(LIBPATH) $(LIBS) -o $(EXECUTABLE4)

genrand: $(GENRANDOBJS)
	$(COMPILE) $(LDFLAGS) $(GENRANDOBJS) $(LIBPATH) $(LIBS) -o $(EXECUTABLE3)

logparser: $(PARSEROBJS)
	$(COMPILE) $(LDFLAGS) $(PARSEROBJS) $(LIBPATH) $(LIBS)	-o $(EXECUTABLE5)

logparser.o: logparser.c Makefile bench.h
	$(COMPILE+) -c logparser.c -o logparser.o

replay_log.o: replay_log.c Makefile bench.h
	$(COMPILE+) -c replay_log.c -o replay_log.o	
webclient-async.o: webclient-async.c Makefile
	$(COMPILE+) -c webclient-async.c -o webclient-async.o

get-async.o: get-async.c Makefile
	$(COMPILE+) -c get-async.c -o get-async.o	
.c.o: Makefile
	$(COMPILE) -c $< -o $@
