#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>

#ifndef WIN32
#include <netdb.h>
#include <sys/param.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/errno.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#else /* defined(WIN32) */
#include <windows.h>
#include <process.h>
#include <time.h>
#include <winsock.h>
#endif /* WIN32 */

#include "sysdep.h"
#include "bench.h"

void clean_answer_file(char **answer_list){
  int i=0;
  for(i=0; i<MAX_ANSWERS; i++){
    if(answer_list[i])
      free(answer_list[i]);
  }
}

void parse_answer_file(FILE * f, char ** answer_list)
{

  char line[BUFSIZE];
  char str_answer[BUFSIZE];
  char * textvalue;
  char * tmpptr;
  int num_answers=0;
  int returnval;
  int idx;

  D_PRINTF("parse_answer_file(): Entering\n");

  while(fgets(line, BUFSIZE, f) != NULL) {
    
    memset(str_answer, 0, BUFSIZE);
    textvalue = line;
    /* check for comments */
    if ((tmpptr = strchr(textvalue, '#')) != NULL)
      {

	/* throw out anything after a '#' */
	D_PRINTF( "Stripping comment from line: %s\n", textvalue );
	returnval = strcspn(textvalue, "#");
	D_PRINTF( "Found first # at %d\n", returnval );
	if (returnval == 0) 
	  continue;
	for (tmpptr--; isspace(*tmpptr) && tmpptr != textvalue; tmpptr--);
	/* set everything after the '#' sign to null */
	if (tmpptr != textvalue) {
	  int len = tmpptr + 1 - line;
	  memset(tmpptr+1, 0, strlen(line) - len);
	}
	D_PRINTF( "Stripped  comment from line: %s\n", textvalue );
	if (tmpptr == textvalue)
	  continue;	/* line was just white space and comment */
      }
    for (tmpptr = line; *tmpptr && isspace(*tmpptr); tmpptr++);
    if (*tmpptr == '\0')
      continue;	/* line was white space only */

    if (num_answers > MAX_ANSWERS) {
      errexit("No more answers from file\n");
      return;
    }


    D_PRINTF( "Extracting values\n");
    if (textvalue != NULL)
      returnval = sscanf(textvalue, "%d%s", &idx, str_answer);

    if (str_answer) {
      D_PRINTF( "Parsed answer line: %d %s\n", idx, str_answer );
      answer_list[idx] = (char *)mymalloc(strlen(str_answer)+1);
      sprintf(answer_list[idx], "%s", str_answer );
    }

    num_answers++;
  }
}
